'
' Test program for the EDM32.INC custom control editor.
' Shows most of the basic features in the editor control.
' Public Domain by Borje Hagsten, July 2001
'
' LOG:
' October 15, 2004: See EDM32.INC for more info.
' April   15, 2003: Cleaned up this sample code and now use COMDLG32.INC
'                   instead of own implementations of the Open/Save file
'                   dialog routines in it. Also did some changes to the
'                   include file. See EDM32.INC for more info.
'
' EDM32.INC updated and corrected to work with PBWin 7.04 - Oct 2004
' testedm.bas updated and corrected to work with PBWin 7.04 - Oct 2004
' (some asciiz changes in 7.01 affected old open/save file dialog code)
'
'
$COMPILE EXE
#RESOURCE "EDM32.PBR"   'EDM32 resource file, with right-hand cursor
'--------------------------------------------------------------------
#INCLUDE "WIN32API.INC" 'Win API declares, etc.
#INCLUDE "COMDLG32.INC" 'Open/Save dlg declares, etc.
#INCLUDE "EDM32.INC"    'EDM32 include file
'--------------------------------------------------------------------
%ID_NEW      = 110       'Control Id's
%ID_OPEN     = 111
%ID_SAVE     = 112
%ID_LBL1     = 130
%ID_LBL2     = 131
%ID_LBL3     = 132
%ID_LBL4     = 133
%ID_COMBO    = 140
%ID_EDIT     = 150
%ID_UNDO     = 160
%ID_REDO     = 161
%ID_CUT      = 162
%ID_COPY     = 163
%ID_PASTE    = 164
%ID_DELETE   = 165
%ID_SELALL   = 166
%ID_UCASE    = 170
%ID_LCASE    = 171
%ID_MCASE    = 172
%ID_TCASE    = 173
%ID_REM      = 180
%ID_NOREM    = 181
%ID_INDENT   = 182
%ID_OUTDENT  = 183
%ID_SORTASC  = 184
%ID_SORTDESC = 186
%ID_BMSET    = 190
%ID_BMSUBS   = 191
%ID_BMNEXT   = 193
%ID_BMPREV   = 194
%ID_BMCLEAR  = 195
%ID_SYNTAX   = 200
%ID_GRID     = 201
%ID_SNPRINT  = 202
%ID_DOCINFO  = 210
'--------------------------------------------------------------------
GLOBAL ghCombo AS DWORD, ghEdit AS DWORD, ghMenuPopup AS DWORD, ghMenuPop4 AS DWORD
'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION DlgMainProc
DECLARE FUNCTION CheckSaveStatus(BYVAL hDlg AS DWORD) AS LONG
DECLARE SUB OpenEdmFile(BYVAL hDlg AS DWORD)
DECLARE SUB SaveEdmFile(BYVAL hDlg AS DWORD)
DECLARE SUB ShowMenuEdit

'
' Program Entrance
'--------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG
  LOCAL hDlg AS DWORD
  DIALOG NEW 0, "EDM32 code editor demo  -  Right-click for edit menu..",,, _
                 392, 236, %WS_OVERLAPPEDWINDOW TO hDlg

  ghEdit = CreateEdm32edit(hDlg, %ID_EDIT, -2, 22, 395, 216, _
                          %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR _
                          %WS_VSCROLL OR %WS_HSCROLL, %WS_EX_CLIENTEDGE, 1)
  SendMessage ghEdit, %EDM_SETBMCOLOR, RGB(0,255,255), 0 'set new bookmark color (default is red)
  SendMessage ghEdit, %EDM_SETKBSHORTCUTS, %TRUE, 0      'tell control to use internal keyboard shortcuts

  CONTROL ADD BUTTON, hDlg,   %ID_NEW,  "New",        4, 4,  40,  14
  CONTROL ADD BUTTON, hDlg,   %ID_OPEN, "Open..",    46, 4,  40,  14
  CONTROL ADD BUTTON, hDlg,   %ID_SAVE, "Save as..", 88, 4,  40,  14
  CONTROL ADD BUTTON, hDlg,   %IDCANCEL, "Exit",    132, 4,  40,  14
  CONTROL ADD LABEL, hDlg,    %ID_LBL1, " Line: 1", 176, 1,  50,  10, %SS_SUNKEN
  CONTROL ADD LABEL, hDlg,    %ID_LBL2, " Col:  1", 226, 1,  50,  10, %SS_SUNKEN
  CONTROL ADD LABEL, hDlg,    %ID_LBL3, " Len:  0", 176, 11, 50,  10, %SS_SUNKEN
  CONTROL ADD LABEL, hDlg,    %ID_LBL4, " Sel:  0", 226, 11, 50,  10, %SS_SUNKEN
  CONTROL ADD COMBOBOX, hDlg, %ID_COMBO, ,          280, 4, 110, 200, %CBS_DROPDOWNLIST OR _
                                                                      %CBS_SORT OR %WS_VSCROLL
  CONTROL HANDLE hDlg, %ID_COMBO TO ghCombo         'store combo's handle in global variable
  edmGetSubs ghEdit, ghCombo, 0                     'initialize sub/function finder combo

  DIALOG SHOW MODAL hDlg, CALL DlgMainProc
END FUNCTION

'
' Dialog Callback procedure
'--------------------------------------------------------------------
CALLBACK FUNCTION DlgMainProc

  SELECT CASE CBMSG
     CASE %WM_INITDIALOG
       LOCAL lRes AS LONG, lRes2 AS LONG, lRes3 AS LONG, lRes4 AS LONG, rc AS RECT
       LOCAL f AS STRING, nm AS NMHDR PTR
       '  Note - always use fixed-width fonts like Courier or Fixedsys, etc.
       CALL edmSetFontEditor(ghEdit, "Courier New", 9, 0, 0, 0)
       DIALOG DOEVENTS

     CASE %EDM_SETINFO 'trap notification from editor control, and get/show info in labels
        CONTROL SET TEXT CBHNDL, %ID_LBL1, " Line: " + _
                         STR$(SendMessage(ghEdit, %EDM_GETCARETY, 0, 0) + 1)
        CONTROL SET TEXT CBHNDL, %ID_LBL2, " Col: " + _
                         STR$(SendMessage(ghEdit, %EDM_GETCARETX, 0, 0) + 1)
        CONTROL SET TEXT CBHNDL, %ID_LBL3, " Len: " + _
                         STR$(SendMessage(ghEdit, %EDM_GETTEXTLEN, 0, 0))
        CONTROL SET TEXT CBHNDL, %ID_LBL4, " Sel: " + _
                         STR$(SendMessage(ghEdit, %EDM_GETSELLENGTH, 0, 0))

     CASE %WM_COMMAND
        SELECT CASE CBCTL ' handle all controls and response from right-click edit menu here
           CASE %ID_NEW
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 IF Sendmessage(ghEdit, %EDM_GETTEXTLEN, 0, 0) THEN            'is there any text?
                    IF CheckSaveStatus(CBHNDL) = %IDCANCEL THEN EXIT FUNCTION  'need to save?
                    CALL SendMessage(ghEdit, %EDM_LOADFILE, 0, 1)              'clear control, lParam sets focus
                 ELSE
                    SetFocus ghEdit                                            'else simply return focus to editor
                 END IF
              END IF

           CASE %ID_OPEN
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN OpenEdmFile CBHNDL 'Show Open File dialog
           CASE %ID_SAVE
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SaveEdmFile CBHNDL 'Show Save File dialog
           CASE %IDCANCEL
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 IF CheckSaveStatus(CBHNDL) <> %IDCANCEL  THEN 'need to save before exiting?
                    DIALOG END CBHNDL                          'if not Cancel, we can close the program
                 END IF
              END IF

           CASE %ID_COMBO                       'Sub/Function finder combo
              SELECT CASE HIWRD(CBWPARAM)
                 CASE %CBN_DROPDOWN             'Refresh list
                    edmGetSubs ghEdit, ghCombo, 0

                 CASE %CBN_SELENDOK             'go to selected function/sub
                    SetFocus ghEdit             'close combo before going..
                    lRes = SendMessage(ghCombo, %CB_GETCURSEL, 0, 0)
                    lRes = SendMessage(ghCombo, %CB_GETITEMDATA, lRes, 0)
                    CALL SendMessage(ghEdit, %EDM_GOTOLINE, lRes, 1)
              END SELECT

       'POPUP MENU COMMANDS
           CASE %ID_UNDO
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_UNDO, 0, %TRUE
           CASE %ID_REDO
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_REDO, 0, %TRUE

           CASE %ID_CUT
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %WM_CUT, 0, 0
           CASE %ID_COPY
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_COPY, 0, 0
           CASE %ID_PASTE
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_PASTE, 0, 0
           CASE %ID_DELETE
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_DELETE, 0, -1
           CASE %ID_SELALL
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EM_SETSEL, 0, -1

           CASE %ID_UCASE
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_UCASE, 0, -1
           CASE %ID_LCASE
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_LCASE, 0, -1
           CASE %ID_MCASE
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_MCASE, 0, -1
           CASE %ID_TCASE
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_TCASE, 0, -1

           CASE %ID_REM
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_COMMENT, 0, 0
           CASE %ID_NOREM
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_COMMENT, 0, 1
           CASE %ID_INDENT
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_COMMENT, 0, 2
           CASE %ID_OUTDENT
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_COMMENT, 0, 3
           CASE %ID_SORTASC
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_SORTLINES, 1, 0
           CASE %ID_SORTDESC
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_SORTLINES, 3, 0

           CASE %ID_BMSET
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_SETBMARK, 0, 0
           CASE %ID_BMSUBS
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN edmGetSubs ghEdit, 0, 0
           CASE %ID_BMNEXT
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_NEXTBMARK, 0, 0
           CASE %ID_BMPREV
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_PREVBMARK, 0, 0
           CASE %ID_BMCLEAR
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN SendMessage ghEdit, %EDM_RESETBMARKSALL, 0, 0

           CASE %ID_SYNTAX 'Toggle syntax coloring
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 IF SendMessage(ghEdit, %EDM_GETSYNTAXONOFF, 0, 0) THEN
                    CALL SendMessage(ghEdit, %EDM_SETSYNTAXONOFF, 0, 0)
                    CALL CheckMenuItem(ghMenuPop4, %ID_SYNTAX, %MF_CHECKED)
                 ELSE
                    CALL SendMessage(ghEdit, %EDM_SETSYNTAXONOFF, 1, 0)
                    CALL CheckMenuItem(ghMenuPop4, %ID_SYNTAX, %MF_UNCHECKED)
                 END IF
              END IF

           CASE %ID_SNPRINT 'Show/hide non-printable characters
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 IF SendMessage(ghEdit, %EDM_GETSHOWNONPRINT, 0, 0) THEN
                    CALL SendMessage(ghEdit, %EDM_SETSHOWNONPRINT, 0, 0)
                    CALL CheckMenuItem(ghMenuPop4, %ID_SNPRINT, %MF_CHECKED)
                 ELSE
                    CALL SendMessage(ghEdit, %EDM_SETSHOWNONPRINT, 1, 0)
                    CALL CheckMenuItem(ghMenuPop4, %ID_SNPRINT, %MF_UNCHECKED)
                 END IF
              END IF

           CASE %ID_GRID 'Toggle gridlines
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 IF SendMessage(ghEdit, %EDM_GETGRID, 0, 0) THEN
                    CALL SendMessage(ghEdit, %EDM_SETGRID, 0, 0)
                    CALL CheckMenuItem(ghMenuPop4, %ID_GRID, %MF_CHECKED)
                 ELSE
                    CALL SendMessage(ghEdit, %EDM_SETGRID, 1, 0)
                    CALL CheckMenuItem(ghMenuPop4, %ID_GRID, %MF_UNCHECKED)
                 END IF
              END IF

           CASE %ID_DOCINFO 'Show statistics
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 f = edmGetFileName(ghEdit)
                 IF LEN(f) THEN
                    f = MID$(f, INSTR(-1, f, "\") + 1)  'dialog will return full path and file name
                 ELSE
                    f = "Untitled.bas"
                 END IF
                 lRes  = Sendmessage(ghEdit, %EDM_GETWORDCOUNT, 0, -1) 'word count in selected text
                 lRes2 = Sendmessage(ghEdit, %EDM_GETWORDCOUNT, 0, 0)  'word count in whole text
                 lRes3 = Sendmessage(ghEdit, %EDM_GETTEXTLEN, 0, 0)    'Text length
                 lRes4 = Sendmessage(ghEdit, %EDM_GETSELLENGTH, 0, 0)  'Selection length
                 MSGBOX "File: " & f & $CRLF & $CRLF & _
                        "Length: " & STR$(lRes3) & " bytes." & $CRLF & _
                        "SelLen: " & STR$(lRes4) & " bytes." & $CRLF & $CRLF & _
                        "Word count, whole text: " & STR$(lRes2) & $CRLF & _
                        "Word count, selection:  " & STR$(lRes) & $CRLF & $CRLF & _
                        edmTxtGetFileSummary(ghEdit)
              END IF

        END SELECT

     CASE %WM_NCACTIVATE
        IF CBWPARAM THEN CALL SetFocus(ghEdit)  '<- set focus to editor control

     CASE %WM_NOTIFY
        nm = CBLPARAM                           '%NM_RCLICK = %NM_FIRST-5
        IF @nm.hWndFrom = ghEdit AND @nm.code = %NM_FIRST-5 THEN ShowMenuEdit

     CASE %WM_SIZE 'resize edit control if parent is resized
        IF CBWPARAM <> %SIZE_MINIMIZED THEN
           GetWindowRect ghEdit, rc            ' get control's coordinates on screen
           MapWindowPoints 0, CBHNDL, rc, 2    ' map result to dialog - we need top pos
           SetWindowPos ghEdit, 0, 0, 0, LOWRD(CBLPARAM) + 4, _  ' width
                        HIWRD(CBLPARAM) - rc.nTop + 2, _         ' height
                        %SWP_NOMOVE OR %SWP_NOZORDER
        END IF

     CASE %WM_SYSCOMMAND
        IF CBWPARAM = %SC_CLOSE THEN
           IF CheckSaveStatus(CBHNDL) = %IDCANCEL  THEN 'need to save before exiting?
              FUNCTION = 1: EXIT FUNCTION               'if cancel, return 1 to break action
           END IF
        END IF

  END SELECT
END FUNCTION

'
' Build and show popup menu on right-click
'
SUB ShowMenuEdit
  LOCAL editFlag  AS LONG, readFlag  AS LONG, selFlag   AS LONG, _
        txtFlag   AS LONG, sortFlag  AS LONG, _
        hMenuPop1 AS DWORD, hMenuPop2 AS DWORD, hMenuPop3 AS DWORD, _
        txt       AS STRING, pt AS POINTAPI

  GetCursorPos pt                                                   'GET CURSOR'S POSITION ON SCREEN

  editFlag = %MF_GRAYED : readFlag = %MF_GRAYED : selFlag = %MF_GRAYED 'pre-set these as grayed
  txtFlag = %MF_GRAYED  : sortFlag = %MF_GRAYED

  IF SendMessage(ghEdit, %EDM_GETTEXTLEN, 0, 0) THEN                'if text exist
     txtFlag = %MF_ENABLED                                          'set txtFlag
  END IF

  IF SendMessage(ghEdit, %EDM_GETSELLENGTH, 0, 0) THEN              'if selection exist
     selFlag = %MF_ENABLED                                          'set selFlag
  END IF

  IF SendMessage(ghEdit, %EDM_GETREADONLY, 0, 0) = 0 THEN           'and editing is possible
     readFlag = %MF_ENABLED                                         'editing allowed, set readFlag
     IF selFlag = %MF_ENABLED THEN editFlag = %MF_ENABLED           'all ok, so change to enabled
  END IF

  IF SendMessage(ghEdit, %EDM_GETLINECOUNT, 0, 0) THEN              'See if text exist
     IF SendMessage(ghEdit, %EDM_GETSELSTARTY, 0, 0) <> _           'if >1 lines are selected
        SendMessage(ghEdit, %EDM_GETSELENDY, 0, 0) THEN

        sortFlag = %MF_ENABLED                                      'set sortFlag
     END IF
  END IF


  MENU NEW POPUP TO ghMenuPopup                                     'BUILD MENU

  txt = edmUndoGetDescription(ghEdit, -1) + CHR$(9) + "Ctrl + Z"    'UNDO
  IF SendMessage(ghEdit, %EDM_CANUNDO, 0, 0) THEN
     MENU ADD STRING, ghMenuPopup, txt, %ID_UNDO, %MF_ENABLED
  ELSE
     MENU ADD STRING, ghMenuPopup, txt, %ID_UNDO, %MF_GRAYED
  END IF

  txt = edmUndoGetDescription(ghEdit, 0) + CHR$(9) + "Ctrl + Y"     'REDO
  IF SendMessage(ghEdit, %EDM_CANREDO, 0, 0) THEN
     MENU ADD STRING, ghMenuPopup, txt, %ID_REDO, %MF_ENABLED
  ELSE
     MENU ADD STRING, ghMenuPopup, txt, %ID_REDO, %MF_GRAYED
  END IF

  MENU ADD STRING, ghMenuPopup, "-",           0, 0                 'SEPARATOR

  txt = "Cut" + CHR$(9) + "Ctrl + X"
  MENU ADD STRING, ghMenuPopup, txt, %ID_CUT, editFlag              'CUT

  IF selFlag = %MF_ENABLED THEN                                     'COPY
     txt = "Copy selection" + CHR$(9) + "Ctrl + C"
  ELSE
     txt = "Copy all" + CHR$(9) + "Ctrl + C"
  END IF
  MENU ADD STRING, ghMenuPopup, txt, %ID_COPY, txtFlag

  IF IsClipboardFormatAvailable(%CF_TEXT) AND readFlag = %MF_ENABLED THEN 'PASTE
     MENU ADD STRING, ghMenuPopup, "Paste" + CHR$(9) + "Ctrl + V", %ID_PASTE, %MF_ENABLED
  ELSE
     MENU ADD STRING, ghMenuPopup, "Paste" + CHR$(9) + "Ctrl + V", %ID_PASTE, %MF_GRAYED
  END IF

  MENU ADD STRING, ghMenuPopup, "Delete", %ID_DELETE, editFlag      'DELETE
  MENU ADD STRING, ghMenuPopup, "-",           0, 0                 'SEPARATOR
  MENU ADD STRING, ghMenuPopup, "Select All" + CHR$(9) + _
                                "Ctrl + A", %ID_SELALL, txtFlag     'SELECT ALL
  MENU ADD STRING, ghMenuPopup, "-",           0, 0                 'SEPARATOR

  MENU NEW POPUP TO hMenuPop1 '<- nested menu for line procedures
  MENU ADD POPUP, ghMenuPopup, " Line(s)..." , hMenuPop1,  readFlag
     MENU ADD STRING, hMenuPop1, "Rem out", %ID_REM, %MF_ENABLED
     MENU ADD STRING, hMenuPop1, "Remove Rem out", %ID_NOREM, %MF_ENABLED
     MENU ADD STRING, hMenuPop1, "-",           0, 0
     MENU ADD STRING, hMenuPop1, "Indent" + CHR$(9) + "TAB", %ID_INDENT, %MF_ENABLED
     MENU ADD STRING, hMenuPop1, "Outdent" + CHR$(9) + "Shift + TAB", %ID_OUTDENT, %MF_ENABLED
     MENU ADD STRING, hMenuPop1, "-",           0, 0
     MENU ADD STRING, hMenuPop1, "Sort ascending", %ID_SORTASC, sortFlag
     MENU ADD STRING, hMenuPop1, "Sort descending", %ID_SORTDESC, sortFlag

  MENU NEW POPUP TO hMenuPop2 '<- nested menu for text case procedures
  MENU ADD POPUP, ghMenuPopup, " Shift Case to..." , hMenuPop2,  editFlag
     MENU ADD STRING, hMenuPop2, "UPPER CASE" + CHR$(9) + "Ctrl + U", %ID_UCASE, %MF_ENABLED
     MENU ADD STRING, hMenuPop2, "lower case" + CHR$(9) + "Ctrl + L", %ID_LCASE, %MF_ENABLED
     MENU ADD STRING, hMenuPop2, "Mixed Case" + CHR$(9) + "Ctrl + M", %ID_MCASE, %MF_ENABLED
     MENU ADD STRING, hMenuPop2, "tOGGLED cASE" + CHR$(9) + "Ctrl + T", %ID_TCASE, %MF_ENABLED

  MENU NEW POPUP TO hMenuPop3 '<- nested menu for bookmark procedures
  MENU ADD POPUP, ghMenuPopup, " BookMark..." , hMenuPop3,  %MF_ENABLED
     MENU ADD STRING, hMenuPop3, "Toggle on/off" + CHR$(9) + "Ctrl + F2", %ID_BMSET, %MF_ENABLED
     MENU ADD STRING, hMenuPop3, "All Subs/Functions", %ID_BMSUBS, %MF_ENABLED
     MENU ADD STRING, hMenuPop3, "-",           0, 0
     MENU ADD STRING, hMenuPop3, "Goto Next" + CHR$(9) + "F2", %ID_BMNEXT, %MF_ENABLED
     MENU ADD STRING, hMenuPop3, "Goto Previous" + CHR$(9) + "Shift + F2", %ID_BMPREV, %MF_ENABLED
     MENU ADD STRING, hMenuPop3, "-",           0, 0
     MENU ADD STRING, hMenuPop3, "Clear all", %ID_BMCLEAR, %MF_ENABLED

  MENU NEW POPUP TO ghMenuPop4 '<- nested menu for settings
  MENU ADD POPUP, ghMenuPopup, " Settings..." , ghMenuPop4,  %MF_ENABLED
     MENU ADD STRING, ghMenuPop4, "Show syntax coloring" + CHR$(9) + "Ctrl + H", %ID_SYNTAX, %MF_ENABLED
     MENU ADD STRING, ghMenuPop4, "Show Gridlines" + CHR$(9) + "Ctrl + G", %ID_GRID, %MF_ENABLED
     MENU ADD STRING, ghMenuPop4, "Show non-printable characters", %ID_SNPRINT, %MF_ENABLED

  MENU ADD STRING, ghMenuPopup, "-", 0, 0                                   'SEPARATOR
  MENU ADD STRING, ghMenuPopup, "Document info..", %ID_DOCINFO, %MF_ENABLED 'DOCUMENT INFO

  IF SendMessage(ghEdit, %EDM_GETSYNTAXONOFF, 0, 0) THEN
     CALL CheckMenuItem(ghMenuPop4, %ID_SYNTAX, %MF_CHECKED)
  ELSE
     CALL CheckMenuItem(ghMenuPop4, %ID_SYNTAX, %MF_UNCHECKED)
  END IF

  IF SendMessage(ghEdit, %EDM_GETSHOWNONPRINT, 0, 0) THEN
     CALL CheckMenuItem(ghMenuPop4, %ID_SNPRINT, %MF_CHECKED)
  ELSE
     CALL CheckMenuItem(ghMenuPop4, %ID_SNPRINT, %MF_UNCHECKED)
  END IF

  IF SendMessage(ghEdit, %EDM_GETGRID, 0, 0) THEN
     CALL CheckMenuItem(ghMenuPop4, %ID_GRID, %MF_CHECKED)
  ELSE
     CALL CheckMenuItem(ghMenuPop4, %ID_GRID, %MF_UNCHECKED)
  END IF

  TrackPopupMenu ghMenuPopup, 0, pt.x, pt.y, 0, ghEdit, BYVAL %NULL

END SUB

'
' Check if editor's contents needs saving
'
FUNCTION CheckSaveStatus (BYVAL hDlg AS DWORD) AS LONG
  LOCAL lRes AS LONG, f AS STRING, Buffer AS STRING

  IF SendMessage(ghEdit, %EDM_GETCHANGED, 0, 0) AND _
     Sendmessage(ghEdit, %EDM_GETTEXTLEN, 0, 0) THEN     'if text has changed and have length

     f      = "Save?" & CHR$(0)                          'enable user to save before opening new
     Buffer = "Save changes to current text?" & CHR$(0)
     lRes = MessageBox(hDlg, BYVAL STRPTR(Buffer), BYVAL STRPTR(f), _
                       %MB_YESNOCANCEL OR %MB_ICONQUESTION)
     IF lRes = %IDYES THEN SaveEdmFile hDlg              'if yes, show Save dialog
     FUNCTION = lRes
  END IF
END FUNCTION

'
' Show Open File dialog
'
SUB OpenEdmFile (BYVAL hDlg AS DWORD)
  LOCAL Style AS DWORD, Buffer AS STRING, f AS STRING, Path AS STRING

  IF CheckSaveStatus(hDlg) = %IDCANCEL THEN EXIT SUB 'need to save before loading new text?

  f      = "*.BAS;*.INC"
  Path   = CURDIR$
  Buffer =          "PB Files (*.BAS, *.INC)|*.BAS;*.INC|"
  Buffer = Buffer & "Resource Files (*.RC)|*.RC|"
  Buffer = Buffer & "Internet Files (*.HTML, *.HTM)|*.html;*.htm|"
  Buffer = Buffer & "Text Files (*.TXT)|*.TXT|"
  Buffer = Buffer & "All Files (*.*)|*.*"
  Style  = %OFN_EXPLORER OR %OFN_FILEMUSTEXIST

  IF OpenFileDialog(hDlg, "", f, Path, Buffer, "BAS" , Style) THEN
      SLEEP 1                                                 'take a breath..
      IF LEN(f) THEN                                          'if we have a file name
         CALL SendMessage(ghEdit, %EDM_LOADFILE, BYVAL STRPTR(f), 0) 'load the file
         IF (Style AND %OFN_READONLY) THEN                    'if ReadOnly was selected
            CALL SendMessage(ghEdit, %EDM_SETREADONLY, 1, 0)  'set ReadOnly mode
         ELSE
            CALL SendMessage(ghEdit, %EDM_SETREADONLY, 0, 0)  'reset ReadOnly mode
         END IF
         CALL edmGetSubs(ghEdit, ghCombo, 0)                  'populate sub/function finder combo
      END IF
  END IF

END SUB

'
' Save edit control's contents to file
'
SUB SaveEdmFile (BYVAL hDlg AS DWORD)
  LOCAL hFile AS DWORD, Style AS DWORD, _
        Buffer AS STRING, Path AS STRING, f AS STRING, fType AS STRING

  Style = %OFN_EXPLORER OR %OFN_FILEMUSTEXIST OR _
          %OFN_HIDEREADONLY OR %OFN_OVERWRITEPROMPT
  Buffer   =          "PB Code Files (*.BAS)|*.BAS|"
  Buffer   = Buffer & "PB Include Files (*.INC)|*.INC|"
  Buffer   = Buffer & "Resource Files (*.RC)|*.RC|"
  Buffer   = Buffer & "Text Files (*.TXT)|*.TXT|"
  Buffer   = Buffer & "All Files (*.*)|*.*"

  f = edmGetFileName(ghEdit)

  IF LEN(f) = 0 THEN
     Path  = CURDIR$
     f     = "Untitled.bas"
     fType = "BAS"
  ELSE
     LOCAL pos AS LONG
     pos = INSTR(-1, f, "\")
     IF pos THEN
        Path = LEFT$(f, pos)
        f    = MID$(f, pos + 1)  'dialog will return full path and file name
        IF INSTR(-1, f, ".") THEN
           fType = edmUCASER(MID$(f, INSTR(-1, f, ".") + 1 ))
        END IF
     END IF
  END IF

  'Show Save dialog. If user selects Cancel in Save dialog, exit.
  IF ISFALSE(SaveFileDialog(hDlg, "", f, Path, Buffer, fType, Style)) THEN EXIT SUB

  SLEEP 1 'take a breath..
  Buffer = edmTxtGetSelText(ghEdit, 0)                    'edmTxtGetSelText returns all text if last param is 0

  hFile = FREEFILE                                        'get free file handle
  OPEN f FOR BINARY AS hFile LEN = 8192                   'open file for binary write
     IF ERR THEN GOTO SaveFileError                       'always consider errors on File I/O
     PUT$ hFile, Buffer                                   'write Buffer to disk
     SETEOF hFile                                         'truncate file to proper length
  CLOSE hFile                                             'close file handle

  SendMessage ghEdit, %EDM_SETCHANGED, 0, 0               'reset changed flag
EXIT SUB

SaveFileError:                                            'Handle errors
  f      = "Error message!" & CHR$(0)
  Buffer = "Error #" + FORMAT$(ERR) + " occurred while trying to save the file."
  CALL MessageBox(hDlg, BYVAL STRPTR(Buffer), BYVAL STRPTR(f), %MB_OK OR %MB_ICONEXCLAMATION)
  ERRCLEAR : RESET
  EXIT SUB
END SUB
